//
//  XMLParser.m
//  books
//
//  Created by Arman Fahmi on 2014.05.26..
//

#import "XMLParser.h"
#import "XMLAppDelegate.h"
#import "Book.h"

@implementation XMLParser

// lekeri az alkalmazas objektum referenciajat, mint Singleton-t majd visszaadja a "this"-t
- (XMLParser *) initXMLParser {
	
	[super init];
	
	appDelegate = (XMLAppDelegate *)[[UIApplication sharedApplication] delegate];
	
	return self;
}

// Kezdo tagek beolvasasa. Ha  <Books> akkor inicializalom a books tombot, egyebkent ha <Book> akkor letrehozok egy uj Book objektumot
- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName
	attributes:(NSDictionary *)attributeDict {
	
	if([elementName isEqualToString:@"Books"]) {
		// tomb inicializalasa
		appDelegate.books = [[NSMutableArray alloc] init];
	}
	else if([elementName isEqualToString:@"book"]) {
		
		//Book objektum inicializalasa
		aBook = [[Book alloc] init];
		
		//Book ID beallitasa az attributumbol
		aBook.bookID = [[attributeDict objectForKey:@"id"] integerValue];
		
		NSLog(@"id beolvasasa :%i", aBook.bookID);
	}
	
	NSLog(@"Elem feldolgozasa: %@", elementName);
}

// egy XML elem ertekenk olvasasa karakterenkent
- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string {
	// ha ures az aktualis elem, akkor letrehozom
	if(!currentElementValue)
		currentElementValue = [[NSMutableString alloc] initWithString:string];
	else // egyebkent hozzaadom a karaktert
		[currentElementValue appendString:string];
	
	NSLog(@"Ertek feldolgozasa: %@", currentElementValue);
	
}

// zaro tag feldolgozasa, itt kapja meg a vegleges erteket a Book objektum megfelelo tagja
- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {
	// </BOOKS> nem kell csinalni semmit
	if([elementName isEqualToString:@"Books"])
		return;
	
	// </Book> elemnel hozzaadom a Book elemet a books tombhoz es felszabaditom
	if([elementName isEqualToString:@"book"]) {
		[appDelegate.books addObject:aBook];
		
		[aBook release];
		aBook = nil;
	}
	else
		[aBook setValue:currentElementValue forKey:elementName];
	
	[currentElementValue release];
	currentElementValue = nil;
}

@end
